# https://grafana.com/docs/loki/latest/send-data/promtail/configuration/

# Configures the server for Promtail.
server:
  http_listen_port: 9080  # HTTP server listen port (0 means random port). Default: 80
  grpc_listen_port: 0     # gRPC server listen port (0 means random port). Default: 9095
  log_level: "info"       # Log only messages with the given severity or above. Supported values [debug, info, warn, error]

# Describes how Promtail connects to multiple instances of Grafana Loki, sending logs to each.
clients:
  - url: http://loki:3100/loki/api/v1/push  # URL is the address of the Loki server. Required.

# Describes how to save read file offsets to disk
positions:
  filename: /tmp/positions.yaml

# Describes how Promtail can scrape logs from a series of targets using a specified discovery method.
scrape_configs:
  - job_name: container_scrape
    static_configs:
    - targets:
        - localhost
      labels:
        job: nginx
        __path__: /var/log/*
        
    pipeline_stages:
    - match:
        selector: '{job="nginx"}'
        stages:
        - regex:
            expression: '^(?P<client_ip>[^ ]*) - - \[(?P<_>[^\]]*)\] "(?P<method>\S+) (?P<path>[^\s]*) HTTP/[0-9.]+" (?P<status>[0-9]{3}) (?P<size>[0-9]+) "-" "(?P<user_agent>[^"]*)"'
        - labels:
            client_ip: "client_ip"
            method: "method"
            path: "path"
            status: "status"
            size: "size"
            # user_agent: "user_agent"